## plasma-workspace 6.6.1

=== applets/CMakeLists.txt ===
add_subdirectory(activitybar)
add_subdirectory(icon)
add_subdirectory(analog-clock)
add_subdirectory(manage-inputmethod)
add_subdirectory(appmenu)
if (KSysGuard_FOUND)
    add_subdirectory(systemmonitor)
    add_subdirectory(devicenotifier)
endif()
add_subdirectory(calendar)
add_subdirectory(digital-clock)
add_subdirectory(keyboardindicator)
add_subdirectory(kicker)
add_subdirectory(lock_logout)
add_subdirectory(mediacontroller)
add_subdirectory(panelspacer)
if(BUILD_CAMERAINDICATOR)
    add_subdirectory(cameraindicator)
endif()
add_subdirectory(clipboard)

add_subdirectory(notifications)
add_subdirectory(systemtray)

=== libtaskmanager/CMakeLists.txt ===
if(BUILD_TESTING)
   add_subdirectory(autotests)
endif()

set(taskmanager_LIB_SRCS
    abstracttasksmodel.cpp
    abstracttasksproxymodeliface.cpp
    abstractwindowtasksmodel.cpp
    activityinfo.cpp
    concatenatetasksproxymodel.cpp
    flattentaskgroupsproxymodel.cpp
    launchertasksmodel.cpp
    startuptasksmodel.cpp
    regionfiltermode.h
    taskfilterproxymodel.cpp
    taskgroupingproxymodel.cpp
    tasksmodel.cpp
    tasktools.cpp
    virtualdesktopinfo.cpp
    waylandstartuptasksmodel.cpp
    waylandtasksmodel.cpp
    windowtasksmodel.cpp
    screencasting.cpp screencasting.h
    screencastingrequest.cpp screencastingrequest.h
)

if (HAVE_X11)
    set(taskmanager_LIB_SRCS
        ${taskmanager_LIB_SRCS}
        xstartuptasksmodel.cpp
        xwindowsystemeventbatcher.cpp xwindowsystemeventbatcher.h
        xwindowtasksmodel.cpp
    )
endif()

add_library(taskmanager ${taskmanager_LIB_SRCS})
add_library(PW::LibTaskManager ALIAS taskmanager)

ecm_add_qml_module(taskmanager
    URI "org.kde.taskmanager"
    VERSION 0.1
    GENERATE_PLUGIN_SOURCE
    DEPENDENCIES QtCore
)

if (Qt6_VERSION VERSION_GREATER_EQUAL "6.8.0")
    set(private_code_option  "PRIVATE_CODE")
endif()
qt6_generate_wayland_protocol_client_sources(taskmanager
    ${private_code_option}
    FILES ${PLASMA_WAYLAND_PROTOCOLS_DIR}/org-kde-plasma-virtual-desktop.xml
    FILES ${PLASMA_WAYLAND_PROTOCOLS_DIR}/plasma-window-management.xml
    FILES ${PLASMA_WAYLAND_PROTOCOLS_DIR}/zkde-screencast-unstable-v1.xml
)

generate_export_header(taskmanager)

target_include_directories(taskmanager PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>" "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR}/taskmanager>")

# Optionally use Qt::Test if available to find a crash
# This can be reverted before release hopefully
find_package(Qt6Test ${QT_MIN_VERSION} CONFIG QUIET)

target_link_libraries(taskmanager
    PUBLIC
        Qt::Core
        Qt::Gui
        Qt::Quick
        KF6::ItemModels
    PRIVATE
        Qt::Concurrent
        Qt::DBus
        Qt::GuiPrivate
        Qt::WaylandClient
        Plasma::Activities
        KF6::ConfigCore
        KF6::I18n
        KF6::KIOCore
        KF6::KIOGui
        KF6::JobWidgets
        KF6::Service
        KF6::WindowSystem
        PW::KWorkspace
)

# Define and link Qt::Test only if available
if(Qt6Test_FOUND)
    target_compile_definitions(taskmanager PRIVATE HAVE_QTTEST=1)
    target_link_libraries(taskmanager PRIVATE Qt::Test)
else()
    target_compile_definitions(taskmanager PRIVATE HAVE_QTTEST=0)
endif()

if (HAVE_X11)
    target_link_libraries(taskmanager PRIVATE KF6::IconThemes)
    target_link_libraries(taskmanager PRIVATE X11::X11)
endif()

set_target_properties(taskmanager PROPERTIES
                      VERSION ${PROJECT_VERSION}
                      SOVERSION 6
                      EXPORT_NAME LibTaskManager)


ecm_qt_declare_logging_category(taskmanager
    HEADER libtaskmanager_debug.h
    IDENTIFIER TASKMANAGER_DEBUG
    CATEGORY_NAME org.kde.plasma.libtaskmanager
    DESCRIPTION "libtaskmanager debug"
    EXPORT PLASMAWORKSPACE
)

install(TARGETS taskmanager EXPORT libtaskmanagerLibraryTargets ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

install(FILES
    abstracttasksmodel.h
    abstracttasksmodeliface.h
    abstracttasksproxymodeliface.h
    abstractwindowtasksmodel.h
    activityinfo.h
    concatenatetasksproxymodel.h
    flattentaskgroupsproxymodel.h
    launchertasksmodel.h
    regionfiltermode.h
    startuptasksmodel.h
    taskfilterproxymodel.h
    taskgroupingproxymodel.h
    tasksmodel.h
    tasktools.h
    virtualdesktopinfo.h
    waylandstartuptasksmodel.h
    waylandtasksmodel.h
    windowtasksmodel.h
    ${CMAKE_CURRENT_BINARY_DIR}/taskmanager_export.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR}/taskmanager COMPONENT Devel
)

if (HAVE_X11)
    install(FILES
        xstartuptasksmodel.h
        xwindowtasksmodel.h
        DESTINATION ${KDE_INSTALL_INCLUDEDIR}/taskmanager COMPONENT Devel
    )
endif()

ecm_finalize_qml_module(taskmanager)

write_basic_config_version_file(${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfigVersion.cmake VERSION "${PROJECT_VERSION}" COMPATIBILITY AnyNewerVersion)

set(CMAKECONFIG_INSTALL_DIR ${KDE_INSTALL_CMAKEPACKAGEDIR}/LibTaskManager)

configure_package_config_file(LibTaskManagerConfig.cmake.in
    "${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfig.cmake
              ${CMAKE_CURRENT_BINARY_DIR}/LibTaskManagerConfigVersion.cmake
        DESTINATION ${CMAKECONFIG_INSTALL_DIR})

install(EXPORT libtaskmanagerLibraryTargets
        NAMESPACE PW::
        DESTINATION ${CMAKECONFIG_INSTALL_DIR}
        FILE LibTaskManagerLibraryTargets.cmake )

=== startkde/CMakeLists.txt ===
add_subdirectory(plasmaautostart)
add_subdirectory(kcminit)
add_subdirectory(waitforname)

if (SYSTEMD_FOUND)
    add_subdirectory(systemd)
endif()

qt_add_dbus_interface(
    startplasma_SRCS
    ${CMAKE_SOURCE_DIR}/ksplash/ksplashqml/org.kde.KSplash.xml
    ksplashinterface
)
ecm_qt_declare_logging_category(startplasma_SRCS HEADER debug.h IDENTIFIER PLASMA_STARTUP CATEGORY_NAME org.kde.startup)

add_library(startplasma OBJECT startplasma.cpp ${startplasma_SRCS})
target_link_libraries(startplasma PUBLIC
    Qt::Core
    Qt::DBus
    KF6::ConfigGui
    KF6::DBusAddons
    KF6::Notifications
    KF6::Package
    Canberra::Canberra
    PW::KLookAndFeel
    PW::KWorkspace
    KNightTime
)

kconfig_target_kcfg_file(startplasma
    FILE ${CMAKE_SOURCE_DIR}/kcms/lookandfeel/lookandfeelsettings.kcfg
    CLASS_NAME LookAndFeelSettings
)

add_executable(startplasma-wayland ${START_PLASMA_COMMON_SRCS} startplasma-wayland.cpp)

target_link_libraries(startplasma-wayland PRIVATE
    startplasma
)

if (WITH_X11_SESSION)
    add_executable(startplasma-x11 ${START_PLASMA_COMMON_SRCS} startplasma-x11.cpp kcheckrunning/kcheckrunning.cpp)

    target_link_libraries(startplasma-x11 PRIVATE
        startplasma
        X11::X11 # for kcheckrunning
    )
endif()

add_subdirectory(plasma-session)
add_subdirectory(plasma-shutdown)
add_subdirectory(session-shortcuts)
add_subdirectory(session-restore)

#FIXME: reconsider, looks fishy
if(NOT CMAKE_INSTALL_PREFIX STREQUAL "/usr")
    set_property(SOURCE startplasma.cpp APPEND PROPERTY COMPILE_DEFINITIONS
        XCURSOR_PATH="~/.local/share/icons:~/.icons:${KDE_INSTALL_FULL_DATAROOTDIR}/icons:$XCURSOR_PATH:/usr/share/icons:/usr/share/pixmaps:/usr/X11R6/lib/X11/icons")
endif()

configure_file(config-startplasma.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-startplasma.h)

install(TARGETS startplasma-wayland ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
if (WITH_X11_SESSION)
    install(TARGETS startplasma-x11 ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})
endif()
install(PROGRAMS plasma-sourceenv.sh DESTINATION ${KDE_INSTALL_LIBEXECDIR})
install(PROGRAMS plasma-dbus-run-session-if-needed DESTINATION ${KDE_INSTALL_LIBEXECDIR})

=== appiumtests/applets/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2024 Fushan Wen <qydwhotmail@gmail.com>
# SPDX-License-Identifier: BSD-3-Clause

add_test(
    NAME analogclocktest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/analogclocktest.py --failfast
)
set_tests_properties(analogclocktest PROPERTIES TIMEOUT 120)

add_test(
    NAME appmenutest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/appmenutest.py --failfast
)
set_tests_properties(appmenutest PROPERTIES TIMEOUT 120 ENVIRONMENT "TEST_WITH_KWIN_WAYLAND=0;CMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

add_test(
    NAME calendartest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/calendartest.py --failfast
)
set_tests_properties(calendartest PROPERTIES TIMEOUT 120)

add_test(
    NAME cameraindicatortest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/cameraindicatortest.py
)
set_tests_properties(cameraindicatortest PROPERTIES TIMEOUT 120 ENVIRONMENT "CMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

add_test(
    NAME clipboardtest_basic
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/clipboardtest.py -k basic
)
add_test(
    NAME clipboardtest_extended
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/clipboardtest.py -k extended
)
add_test(
    NAME clipboarddeadlocktest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/clipboarddeadlocktest.py
)

set_tests_properties(clipboardtest_basic clipboardtest_extended PROPERTIES TIMEOUT 180 ENVIRONMENT "QT_QPA_PLATFORM=wayland;GDK_BACKEND=wayland;GSK_RENDERER=cairo")

add_test(
    NAME devicenotifiertest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/devicenotifiertest.py --failfast
)
set_tests_properties(devicenotifiertest PROPERTIES TIMEOUT 120)

add_test(
    NAME icontest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/icontest.py --failfast
)
set_tests_properties(icontest PROPERTIES TIMEOUT 120)

add_test(
    NAME lock_logouttest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/lock_logouttest.py --failfast
)
set_tests_properties(lock_logouttest PROPERTIES TIMEOUT 120)

add_test(
    NAME manage-inputmethodtest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/manage-inputmethodtest.py --failfast
)
set_tests_properties(manage-inputmethodtest PROPERTIES TIMEOUT 120)

add_test(
    NAME notificationstest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/notificationstest.py
)
set_tests_properties(notificationstest PROPERTIES TIMEOUT 120 ENVIRONMENT "KACTIVITYMANAGERD_PATH=${KDE_INSTALL_FULL_LIBEXECDIR}/kactivitymanagerd;USE_CUSTOM_BUS=1")

add_test(
    NAME digitalclocktest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/digitalclocktest.py --failfast
)
set_tests_properties(digitalclocktest PROPERTIES TIMEOUT 300)

add_subdirectory(kicker)

add_test(
    NAME mediacontrollertest
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/mediacontrollertest.py --failfast
)
set_tests_properties(mediacontrollertest PROPERTIES TIMEOUT 300 ENVIRONMENT "GDK_BACKEND=wayland")

add_test(
    NAME systemtraytest_x11
    COMMAND selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/systemtraytest.py --failfast
)
# StatusIcon only works with the X11 backend
set_tests_properties(systemtraytest_x11 PROPERTIES TIMEOUT 120 ENVIRONMENT "TEST_WITH_KWIN_WAYLAND=0;USE_CUSTOM_BUS=1;GDK_BACKEND=x11;CMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

add_test(
    NAME systemtraytest_wayland
    COMMAND dbus-launch selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/systemtraytest.py --failfast
)
set_tests_properties(systemtraytest_wayland PROPERTIES TIMEOUT 120 ENVIRONMENT "TEST_WITH_XWAYLAND=1;USE_CUSTOM_BUS=1;GDK_BACKEND=x11;QT_QPA_PLATFORM=wayland;CMAKE_RUNTIME_OUTPUT_DIRECTORY=${CMAKE_RUNTIME_OUTPUT_DIRECTORY}")

add_test(
    NAME logoutgreetertest
    COMMAND dbus-launch selenium-webdriver-at-spi-run ${CMAKE_CURRENT_SOURCE_DIR}/logoutgreetertest.py
)
set_tests_properties(logoutgreetertest PROPERTIES TIMEOUT 300 ENVIRONMENT "PLASMA_SESSION_GUI_TEST=1;KDE_INSTALL_FULL_LIBEXECDIR=${KDE_INSTALL_FULL_LIBEXECDIR}")

=== applets/cameraindicator/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Fushan Wen <qydwhotmail@gmail.com>
# SPDX-License-Identifier: BSD-3-Clause

plasma_add_applet(org.kde.plasma.cameraindicator
    QML_SOURCES
        qml/main.qml
        qml/FullRepresentation.qml
    GENERATE_APPLET_CLASS
)

if (BUILD_TESTING)
    add_subdirectory(autotests)
endif()

=== components/containmentlayoutmanager/CMakeLists.txt ===
ecm_add_qml_module(containmentlayoutmanagerplugin
    URI "org.kde.plasma.private.containmentlayoutmanager"
    VERSION 1.0
    GENERATE_PLUGIN_SOURCE
    DEPENDENCIES QtQuick org.kde.plasma.core org.kde.plasma.plasmoid
)

target_sources(containmentlayoutmanagerplugin PRIVATE
    appletcontainer.cpp appletcontainer.h
    configoverlay.cpp configoverlay.h
    appletslayout.cpp appletslayout.h
    abstractlayoutmanager.cpp abstractlayoutmanager.h
    gridlayoutmanager.cpp gridlayoutmanager.h
    itemcontainer.cpp itemcontainer.h
    resizehandle.cpp resizehandle.h
    plasmabackground.cpp plasmabackground.h
)

ecm_target_qml_sources(containmentlayoutmanagerplugin
    SOURCES
    qml/BasicAppletContainer.qml
    qml/ConfigOverlayWithHandles.qml
    qml/PlaceHolder.qml
)

ecm_target_qml_sources(containmentlayoutmanagerplugin
    PRIVATE
    SOURCES
    qml/private/BasicResizeHandle.qml
)

target_link_libraries(containmentlayoutmanagerplugin
        PUBLIC
            Qt::Core
        PRIVATE
            Qt::Qml Qt::Quick
            Plasma::Plasma Plasma::PlasmaQuick
    )

ecm_qt_declare_logging_category(containmentlayoutmanagerplugin
    HEADER containmentlayoutmanager_debug.h
    IDENTIFIER CONTAINMENTLAYOUTMANAGER_DEBUG
    CATEGORY_NAME org.kde.plasma.containmentlayoutmanager
    DESCRIPTION "plasma container layout manager"
    EXPORT PLASMAWORKSPACE
)

ecm_finalize_qml_module(containmentlayoutmanagerplugin)

=== kcms/lookandfeel/CMakeLists.txt ===
add_definitions(-DTRANSLATION_DOMAIN=\"kcm_lookandfeel\")

add_subdirectory(kded)
add_subdirectory(tool)

kcmutils_add_qml_kcm(kcm_lookandfeel)
target_sources(kcm_lookandfeel PRIVATE
    filedialognamefilters.cpp
    kcm.cpp
    lookandfeelnamevalidator.cpp
    screenshotmaker.cpp
)
target_link_libraries(kcm_lookandfeel PRIVATE
    Qt6::DBus
    KF6::ConfigGui
    KF6::I18n
    KF6::KCMUtils
    KF6::KCMUtilsQuick
    KF6::NewStuffCore
    PW::KLookAndFeel
)

kcmutils_generate_module_data(kcm_lookandfeel
    MODULE_DATA_HEADER lookandfeeldata.h
    MODULE_DATA_CLASS_NAME LookAndFeelData
    SETTINGS_HEADERS lookandfeelsettings.h
    SETTINGS_CLASSES LookAndFeelSettings
)

kconfig_target_kcfg_file(kcm_lookandfeel
    FILE lookandfeelsettings.kcfg
    CLASS_NAME LookAndFeelSettings
    DEFAULT_VALUE_GETTERS
    GENERATE_MOC
    GENERATE_PROPERTIES
    MUTATORS
    NOTIFIERS
    PARENT_IN_CONSTRUCTOR
)

install(FILES lookandfeelsettings.kcfg DESTINATION ${KDE_INSTALL_KCFGDIR})
install(FILES lookandfeel.knsrc DESTINATION ${KDE_INSTALL_KNSRCDIR})

=== ksecretprompter/src/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-2-Clause
# SPDX-FileCopyrightText: Marco Martin <notmart@gmail.com>

set(ksecretprompter_SRCS
    main.cpp
    ksecretprompter.cpp
    promptcontext.cpp
)

ecm_qt_declare_logging_category(ksecretprompter_SRCS
    IDENTIFIER "KSecretPrompterDaemon"
    CATEGORY_NAME "ksecretprompter"
    HEADER ksecretprompter_debug.h
    DESCRIPTION "KDE secretService prompter"
)

add_executable(ksecretprompter)

qt_add_dbus_adaptor(ksecretprompter_SRCS
    org.kde.secretprompter.xml
    ksecretprompter.h KSecretPrompter
)

target_compile_definitions(ksecretprompter PRIVATE -DPROJECT_VERSION="${PROJECT_VERSION}")

target_sources(ksecretprompter PRIVATE
    ${ksecretprompter_SRCS}
)

target_link_libraries(ksecretprompter
    KF6::CoreAddons
    KF6::WidgetsAddons
    KF6::Crash
    KF6::I18n
    KF6::DBusAddons
    KF6::WindowSystem
    Qt6::Widgets
    Qt6::DBus
)



install(TARGETS ksecretprompter DESTINATION ${KDE_INSTALL_LIBEXECDIR})

ecm_generate_dbus_service_file(
    NAME org.kde.secretprompter
    EXECUTABLE ${KDE_INSTALL_FULL_LIBEXECDIR}/ksecretprompter
    DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
)

install(FILES org.kde.secretprompter.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== libkmpris/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Fushan Wen <qydwhotmail@gmail.com>
# SPDX-License-Identifier: BSD-3-Clause

include_directories(${CMAKE_CURRENT_BINARY_DIR}/.. ${CMAKE_CURRENT_SOURCE_DIR}/..)

ecm_add_test(fetchinitialplayertest.cpp LINK_LIBRARIES kmpris Qt::Test)
set_tests_properties(
    fetchinitialplayertest
    PROPERTIES
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/..
)

add_test(
    NAME mprisdeclarativetest_Mpris2Model
    COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/mprisdeclarativetest.py "tst_Mpris2Model.qml"
)
add_test(
    NAME mprisdeclarativetest_MultiplexerModel
    COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/mprisdeclarativetest.py "tst_MultiplexerModel.qml"
)
execute_process(COMMAND gcc -print-file-name=libasan.so OUTPUT_VARIABLE LIBASAN_PATH ECHO_OUTPUT_VARIABLE OUTPUT_STRIP_TRAILING_WHITESPACE)
set_tests_properties(
    mprisdeclarativetest_Mpris2Model
    mprisdeclarativetest_MultiplexerModel
    PROPERTIES
        ENVIRONMENT "LC_ALL=en_US.UTF-8;LD_PRELOAD=${LIBASAN_PATH};CMAKE_BINARY_DIR=${CMAKE_BINARY_DIR}/bin;QMLTEST_PATH=$<TARGET_FILE:${QT_CMAKE_EXPORT_NAMESPACE}::qmltestrunner>"
)

if(WITH_X11)
    find_program(xdotool_PATH xdotool REQUIRED)
    find_program(kglobalacceld_PATH kglobalacceld PATHS ${KDE_INSTALL_FULL_LIBEXECDIR} REQUIRED)
    add_test(NAME mediakeystest
        COMMAND python3 ${CMAKE_CURRENT_SOURCE_DIR}/mediakeystest.py ${KDE_INSTALL_FULL_LIBEXECDIR}/kglobalacceld
        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/../../appiumtests
    )
    set_tests_properties(mediakeystest PROPERTIES RUN_SERIAL ON)
endif()

=== runners/baloo/CMakeLists.txt ===
# SPDX-FileCopyrightText: 2023 Alexander Lohnau <alexander.lohnau@gmx.de>
# SPDX-License-Identifier: BSD-2-Clause
add_definitions(-DTRANSLATION_DOMAIN=\"plasma_runner_baloosearch\")

set(baloosearchrunner_SRCS
    baloosearchrunner.cpp
    baloosearchrunner.h)

qt_add_dbus_adaptor(baloosearchrunner_SRCS "org.kde.krunner1.xml" baloosearchrunner.h SearchRunner)
add_executable(baloorunner ${baloosearchrunner_SRCS})

target_link_libraries(baloorunner
  KF6::Runner
  KF6::KIOWidgets
  KF6::I18n
  KF6::Baloo
  KF6::Notifications
  KF6::Crash
  Qt::DBus
)

install(TARGETS baloorunner DESTINATION ${KDE_INSTALL_LIBEXECDIR})

install(
  FILES plasma-runner-baloosearch.desktop
  DESTINATION "${KDE_INSTALL_DATAROOTDIR}/krunner/dbusplugins"
)

ecm_generate_dbus_service_file(NAME org.kde.runners.baloo
    EXECUTABLE ${KDE_INSTALL_FULL_LIBEXECDIR}/baloorunner
    SYSTEMD_SERVICE plasma-baloorunner.service
    DESTINATION ${KDE_INSTALL_DBUSSERVICEDIR}
)

ecm_install_configured_files(INPUT plasma-baloorunner.service.in @ONLY DESTINATION ${KDE_INSTALL_SYSTEMDUSERUNITDIR})

install(FILES org.kde.baloorunner.desktop DESTINATION ${KDE_INSTALL_APPDIR})

=== startkde/kcminit/CMakeLists.txt ===
add_executable(kcminit main.cpp)
target_link_libraries(kcminit
    Qt::Core
    Qt::Gui
    Qt::DBus
    KF6::CoreAddons
    KF6::Service
    KF6::I18n
    KF6::ConfigCore
    PW::KWorkspace
)
install(TARGETS kcminit ${KDE_INSTALL_TARGETS_DEFAULT_ARGS})

ecm_qt_declare_logging_category(kcminit HEADER debug.h IDENTIFIER KCMINIT CATEGORY_NAME org.kde.kcminit)

add_custom_command(TARGET kcminit POST_BUILD
                   COMMAND ${CMAKE_COMMAND} -E create_symlink kcminit kcminit_startup)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/kcminit_startup DESTINATION ${KDE_INSTALL_BINDIR})

ecm_install_configured_files(
    INPUT
        plasma-kcminit-phase1.service.in
        plasma-kcminit.service.in
    DESTINATION
        ${KDE_INSTALL_SYSTEMDUSERUNITDIR}
)

=== applets/kicker/autotests/CMakeLists.txt ===
ecm_add_test(
    testrunnermodel.cpp
    ../runnermodel.cpp
    ../runnermatchesmodel.cpp
    ../abstractmodel.cpp
    ../actionlist.cpp
    ../containmentinterface.cpp
    ../processrunner.cpp
    TEST_NAME testrunnermodel
    LINK_LIBRARIES Qt::Test Qt::Quick KF6::ConfigCore KF6::Runner KF6::Service KF6::I18n KF6::KIOGui KF6::KIOWidgets KF6::JobWidgets Plasma::Plasma Plasma::PlasmaQuick Plasma::Activities Plasma::ActivitiesStats
)

if (${HAVE_APPSTREAMQT})
target_link_libraries(testrunnermodel AppStreamQt)
endif()

set_tests_properties(testrunnermodel PROPERTIES REPEAT UNTIL_PASS:2)

=== debian/changelog ===
plasma-workspace (4:6.6.1-0ubuntu1) resolute; urgency=medium

  * New upstream release (6.6.0)
  * Update install files.
  * Update symbols.
  * New upstream release (6.6.1)

 -- Rik Mills <rikmills@kde.org>  Sat, 28 Feb 2026 22:17:01 +0000

=== debian/control ===
Source: plasma-workspace
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Aurélien COUDERC <coucouf@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: appmenu-gtk3-module,
               breeze-dev (>= 4:6.6.1~),
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               dh-sequence-kf6,
               dh-sequence-pkgkde-symbolshelper,
               dh-sequence-python3,
               dh-sequence-sodeps,
               extra-cmake-modules (>= 6.22.0~),
               kded6-dev (>= 6.22.0~),
               kirigami-addons-dev (>= 1.0.0~),
               knighttime-dev (>= 6.6.1~),
               kscreenlocker-dev (>= 6.6.1~),
               kwayland-dev (>= 4:6.6.1~),
               kwin-dev (>= 4:6.6.1~),
               libappstreamqt-dev (>= 1.0.0~),
               libcanberra-dev,
               libdbus-1-dev,
               libdrm-dev,
               libfontconfig-dev,
               libice-dev,
               libicu-dev,
               libkexiv2qt6-dev,
               libkf6archive-dev (>= 6.22.0~),
               libkf6auth-dev (>= 6.22.0~),
               libkf6baloo-dev (>= 6.22.0~),
               libkf6coreaddons-dev (>= 6.22.0~),
               libkf6crash-dev (>= 6.22.0~),
               libkf6dbusaddons-dev (>= 6.22.0~),
               libkf6declarative-dev (>= 6.22.0~),
               libkf6doctools-dev (>= 6.22.0~),
               libkf6globalaccel-dev (>= 6.22.0~),
               libkf6guiaddons-dev (>= 6.22.0~),
               libkf6holidays-dev (>= 6.22.0~),
               libkf6i18n-dev (>= 6.22.0~),
               libkf6iconthemes-dev (>= 6.22.0~),
               libkf6idletime-dev (>= 6.22.0~),
               libkf6itemmodels-dev (>= 6.22.0~),
               libkf6kcmutils-dev (>= 6.22.0~),
               libkf6kio-dev (>= 6.22.0~),
               libkf6networkmanagerqt-dev (>= 6.22.0~),
               libkf6newstuff-dev (>= 6.22.0~),
               libkf6notifications-dev (>= 6.22.0~),
               libkf6notifyconfig-dev (>= 6.22.0~),
               libkf6package-dev (>= 6.22.0~),
               libkf6parts-dev (>= 6.22.0~),
               libkf6prison-dev (>= 6.22.0~),
               libkf6runner-dev (>= 6.22.0~),
               libkf6statusnotifieritem-dev (>= 6.22.0~),
               libkf6svg-dev (>= 6.22.0~),
               libkf6texteditor-dev (>= 6.22.0~),
               libkf6textwidgets-dev (>= 6.22.0~),
               libkf6unitconversion-dev (>= 6.22.0~),
               libkf6userfeedback-dev (>= 6.22.0~),
               libkf6wallet-dev (>= 6.22.0~),
               libkirigami-dev (>= 6.22.0~),
               libkpipewire-dev (>= 6.6.1~),
               libkscreen-dev (>= 4:6.6.1~),
               libksysguard-dev (>= 4:6.6.1~),
               liblayershellqtinterface-dev (>= 6.6.1~),
               libpackagekitqt6-dev,
               libphonon4qt6-dev (>= 4:4.6.60~),
               libphonon4qt6experimental-dev,
               libpipewire-0.3-dev,
               libplasma-dev (>= 6.6.1~),
               libplasma5support-dev (>= 4:6.6.1~),
               libplasmaactivities-dev (>= 6.6.1~),
               libplasmaactivitiesstats-dev (>= 6.6.1~),
               libpolkit-qt6-1-dev,
               libqalculate-dev (>= 2.0~),
               libquickcharts-dev (>= 6.22.0~),
               libsm-dev,
               libsystemd-dev,
               libudev-dev,
               libwayland-dev,
               libx11-dev,
               libxcb-composite0-dev,
               libxcb-cursor-dev,
               libxcb-damage0-dev,
               libxcb-image0-dev,
               libxcb-randr0-dev,
               libxcb-shape0-dev,
               libxcb-util-dev,
               libxcb-xfixes0-dev,
               libxcb1-dev,
               libxcursor-dev,
               libxfixes-dev,
               libxft-dev,
               libxrender-dev,
               libxtst-dev,
               pkgconf,
               plasma-wayland-protocols (>= 1.6~),
               qcoro-qt6-dev,
               qml6-module-org-kde-prison (>= 6.22.0~),
               qt6-5compat-dev (>= 6.10.0~),
               qt6-base-dev (>= 6.10.0~),
               qt6-base-dev-tools (>= 6.10.0~),
               qt6-declarative-dev (>= 6.10.0~),
               qt6-declarative-private-dev (>= 6.10.0~),
               qt6-location-dev (>= 6.10.0~),
               qt6-positioning-dev (>= 6.10.0~),
               qt6-shadertools-dev (>= 6.10.0~),
               qt6-svg-dev (>= 6.10.0~),
               qt6-wayland-dev (>= 6.10.0~),
               systemd-dev,
               zlib1g-dev,
Standards-Version: 4.7.0
Homepage: https://invent.kde.org/plasma/plasma-workspace
Vcs-Browser: https://code.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/plasma-workspace
Vcs-Git: https://git.launchpad.net/~kubuntu-packagers/kubuntu-packaging/+git/plasma-workspace
Rules-Requires-Root: no

Package: libbatterycontrol6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace battery control library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This package contains the battery control library files.

Package: libkfontinst6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace fonts installation library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This package contains the fonts installation library files.

Package: libkfontinstui6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace UI components for fonts installation
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This library provides UI components to manage fonts installation
 used in the fonts installation KCM configuration screen.
 .
 This package contains the library files for the fonts installation
 UI components.

Package: libklipper6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspaces Klipper library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 Klipper is the Plasma clipboard utility. It stores clipboard
 history, and allows you to link clipboard contents to application
 actions.
 .
 This package contains the Klipper library files.

Package: libklookandfeel6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspaces KLookAndFeel library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This package contains the KLookAndFeel library files.

Package: libkmpris6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace MPRIS library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This library can be used to control Media Player Remote Interfacing
 Specification-compatible media players.
 .
 This package contains Plasma Workspace MPRIS library files.

Package: libkworkspace6-6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This library provides the core features of Plasma Workspace like
 display, login and session management.
 .
 This package contains the main Plasma Workspace library files.

Package: libnotificationmanager1
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace notification manager library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 This library is responsible for listing notifications, closing them
 and interacting with them in Plasma.
 .
 This package contains the notification manager library files.

Package: libtaskmanager6
Architecture: any
Section: libs
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: Plasma Workspace task manager library
 Plasma Workspace is used as the base for Plasma Desktop, Mobile, and
 Bigscreen. It contains shared KCM configuration screens, applets as
 well as multiple libraries.
 .
 The task manager library provides various abstractions for listing
 windows, startup tasks and launcher jobs.
 .
 This package contains the task manager library files.

Package: plasma-session-wayland
Architecture: any
Depends: kwin-wayland (>= 4:6.4.0~),
         plasma-workspace (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: plasma-workspace (<< 4:6.4.3), plasma-workspace-wayland,
Replaces: plasma-workspace (<< 4:6.4.3), plasma-workspace-wayland,
Description: Plasma Workspace for KF6
 Plasma Workspace for KF6. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This package contains the Wayland session files.

Package: plasma-session-x11
Architecture: any
Depends: plasma-workspace (= ${binary:Version}),
         xorg,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: kwin-x11 (>= 4:6.4.0~),
Breaks: plasma-workspace (<< 4:6.4.3),
Replaces: plasma-workspace (<< 4:6.4.3),
Description: Plasma Workspace for KF6
 Plasma Workspace for KF6. Workspaces provide
 support for KDE Plasma Widgets, integrated search,
 hardware management and a high degree of customizability.
 .
 This package contains the X11 session files.

Package: plasma-workspace
Architecture: any
Depends: default-dbus-session-bus | dbus-session-bus,
         drkonqi (>= 6.2.90~),
         frameworkintegration6,
         gdb,
         iso-codes,
         kactivitymanagerd (>= 6.2.90~),
         kded6,
         kglobalacceld (>= 6.2.90~),
         knighttime (>= 6.5.0~),
         kwin-common (>= 4:6.2.90~),
         kwin-wayland (>= 4:6.2.90~),
         libkf6config-bin,
         milou (>= 4:6.2.90~),
         plasma-desktoptheme,
         plasma-integration (>= 6.2.90~),
         plasma-workspace-data (>= ${source:Version}),
         python3:any,
         qdbus-qt6,
         qml6-module-org-kde-activities,
         qml6-module-org-kde-breeze,
         qml6-module-org-kde-config,
         qml6-module-org-kde-coreaddons,
         qml6-module-org-kde-draganddrop,
         qml6-module-org-kde-kcmutils,
         qml6-module-org-kde-kholidays,
         qml6-module-org-kde-kirigami,
         qml6-module-org-kde-kirigamiaddons-components,
         qml6-module-org-kde-kitemmodels,
         qml6-module-org-kde-kquickcontrols,
         qml6-module-org-kde-kquickcontrolsaddons,
         qml6-module-org-kde-ksvg,
         qml6-module-org-kde-ksysguard,
         qml6-module-org-kde-kwindowsystem,
         qml6-module-org-kde-newstuff,
         qml6-module-org-kde-notifications,
         qml6-module-org-kde-pipewire,
         qml6-module-org-kde-plasma-plasma5support,
         qml6-module-org-kde-prison,
         qml6-module-org-kde-quickcharts,
         qml6-module-org-kde-userfeedback,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtcore,
